TestCase subclass: #ClubTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP0-Tests'!

!ClubTest methodsFor: 'tests' stamp: 'aaa 3/28/2019 17:11'!
testClubDevuelveListaDeSocios
	| club listaDeSocios |
	club := Club new.
	self agregarSocioAClub: club conNombre: 'Carlos'.
	self agregarSocioVIPAClub: club conNombre: 'Marcio'.
	listaDeSocios := OrderedCollection new.
	listaDeSocios add: 'Carlos'; add: 'Marcio'.
	self should: (listaDeSocios = club listaDeSocios).
	self should: (club cantidadDeSocios = 2).! !

!ClubTest methodsFor: 'tests' stamp: 'aaa 3/28/2019 17:41'!
testClubDevuelveRecaudacion
	| club |
	club := Club new.
	club establecerTarifaSocio: 500.
	club establecerTarifaSocioVIP: 700.
	self agregarSocioAClub: club conNombre: 'Carlos'.
	self agregarSocioVIPAClub: club conNombre: 'Marcio'.
	club recibirPagoDe: 'Carlos'.
	club recibirPagoDe: 'Marcio'.
	self should: (club recaudacionTotal = 1200).
! !

!ClubTest methodsFor: 'tests' stamp: 'aaa 3/28/2019 16:32'!
testClubVacio
	| club recaudacion |
	club := Club new.
	recaudacion := club recaudacionTotal.
	self should: (recaudacion = 0).
	self should: (club cantidadDeSocios = 0).
	self should: (((club listaDeSocios) size) = 0).
! !


!ClubTest methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 16:43'!
agregarSocioAClub: unClub conNombre: unNombre
	| socio1 |
	socio1 := Socio new.
	socio1 establecerNombre: unNombre.
	unClub agregarSocio: socio1.
! !

!ClubTest methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 16:44'!
agregarSocioVIPAClub: unClub conNombre: unNombre
	| socio1 |
	socio1 := Socio new.
	socio1 establecerNombre: unNombre.
	unClub agregarSocioVIP: socio1.

! !


TestCase subclass: #SocioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP0-Tests'!

!SocioTest methodsFor: 'tests' stamp: 'aaa 3/28/2019 16:26'!
testSocioDevuelveSuNombre
	| socio1 |
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.
	self should: (socio1 nombre =  'Carlos').
! !
