Object subclass: #Categoria
	instanceVariableNames: 'tarifa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP0'!

!Categoria methodsFor: 'accessing' stamp: 'aaa 3/28/2019 17:22'!
tarifa
	^ tarifa.
	! !


!Categoria methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:22'!
establecerTarifa: unaTarifa
	tarifa := unaTarifa.
	! !


Object subclass: #Club
	instanceVariableNames: 'listaMiembros categoriaRegular categoriaVIP'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP0'!

!Club methodsFor: 'initialization' stamp: 'aaa 3/28/2019 17:23'!
initialize
	listaMiembros := OrderedCollection new.
	categoriaRegular := Categoria new.
	categoriaVIP := Categoria new.

! !


!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:21'!
agregarSocio: unSocio
	| miembro |
	miembro := Miembro conSocio: unSocio yCategoria: categoriaRegular.
	listaMiembros add: miembro.
! !

!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:21'!
agregarSocioVIP: unSocio
	| miembro |
	miembro := Miembro conSocio: unSocio yCategoria: categoriaVIP.
	listaMiembros add: miembro.
! !

!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 18:03'!
recaudacionTotal
	^ listaMiembros inject: 0 into:  [ :sum :miembro |
		sum + (miembro cantidadTotalPagada).
		 ].
! !

!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:24'!
establecerTarifaSocioVIP: unaTarifa
	categoriaVIP establecerTarifa: unaTarifa.
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:10'!
listaDeSocios
	| listaNombres |
	listaNombres := OrderedCollection new.
	listaMiembros do: [ :miembro |
		listaNombres add: (miembro nombre).
	].
	^ listaNombres.
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:37'!
recibirPagoDe: unNombre
	| miembro |
	miembro := listaMiembros detect: [ :unMiembro | 
		(unMiembro nombre = unNombre). 
	].
	miembro registrarPago.
! !

!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:23'!
establecerTarifaSocio: unaTarifa
	categoriaRegular establecerTarifa: unaTarifa.
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 16:33'!
cantidadDeSocios
	 ^ (listaMiembros size).
! !


Object subclass: #Miembro
	instanceVariableNames: 'socio categoria pagos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP0'!

!Miembro methodsFor: 'initialization' stamp: 'aaa 3/28/2019 17:37'!
initialize
	pagos := 0.

! !


!Miembro methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:01'!
establecerSocio: unSocio
socio := unSocio.! !

!Miembro methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:37'!
registrarPago
	pagos := pagos + 1.
! !

!Miembro methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:41'!
cantidadTotalPagada
	^ pagos * (categoria tarifa).

! !

!Miembro methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:03'!
nombre
  ^ socio nombre.
! !

!Miembro methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:01'!
establecerCategoria: unaCategoria
categoria := unaCategoria.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Miembro class
	instanceVariableNames: ''!

!Miembro class methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 17:01'!
conSocio: unSocio yCategoria: unaCategoria
| miembro |
miembro := Miembro new.
miembro establecerSocio: unSocio.
miembro establecerCategoria: unaCategoria.
^ miembro.

! !


Object subclass: #Socio
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP0'!

!Socio methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 16:28'!
nombre
	^ nombre
! !

!Socio methodsFor: 'as yet unclassified' stamp: 'aaa 3/28/2019 16:27'!
establecerNombre: unNombre
	nombre := unNombre.! !
